// LCD
#define	PORTHDDATA		PORTC//   0-3  (   4-7 HD44780)
#define	PINHDDATA		PINC
#define	DDRHDDATA		DDRC

#define	MASKA_HDDATA	0xF0	// 0..3	  /.

//   HD44780.
#define	HDRS			0	//  RS . (	   HD44780)
#define	PORTHDRS		PORTC
#define	PINHDRS			PINC
#define	DDRHDRS			DDRC

#define	SET_RS			PORTHDRS |=	(1<<HDRS)		
//  RS
#define	CLR_RS			PORTHDRS &=	~(1<<HDRS)	
// 	RS

#define	HDE				2	//  E	. (    HD44780)
#define	PORTHDE			PORTC
#define	PINHDE			PINC
#define	DDRHDE			DDRC

#define	SET_E			PORTHDE	|= (1<<HDE)				
//  E
#define	CLR_E			PORTHDE	&= ~(1<<HDE)			
// 	E

#define	HDRW			1	//  R/W . (   	HD44780)
#define	PORTHDRW		PORTC
#define	PINHDRW			PINC
#define	DDRHDRW			DDRC

#define	SET_RW			PORTHDRW |=(1<<HDRW)		
//  RW
#define	CLR_RW			PORTHDRW &=	~(1<<HDRW)

unsigned char buff[10]="          ";//buff for runing string
unsigned char str[]="<<<<<<<<        ";
unsigned char s_pos=0, gl_flags=0;// pos in str[]

const unsigned char TabWin[256] =	{
 0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,   // 
 0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7,   // 
 0xd8, 0xd9, 0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,   // 
 0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec, 0xed, 0xee,   // 
 0xef, 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6,   // 
 0xa2, 0xf7, 0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd,   // 	
 0xfe, 0xff, 0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec,   // 
 0xb5, 0xee, 0xef, 0xf0, 0xf1, 0xf2, 0xfd, 0xff,   // 	
 0x41, 0xa0, 0x42, 0xa1, 0xe0, 0x45, 0xa3, 0xa4,   // 
 0xa5, 0xa6, 0x4b, 0xa7, 0x4d, 0x48, 0x4f, 0xa8,   // 
 0x50, 0x43, 0x54, 0xa9, 0xaa, 0x58, 0xe1, 0xab,   // 
 0xac, 0xe2, 0xad, 0xae, 0x62, 0xaf, 0xb0, 0xb1,   // 
 0x61, 0xb2, 0xb3, 0xb4, 0xe3, 0x65, 0xb6, 0xb7,   // 
 0xb8, 0xb9, 0xba, 0xbb, 0xbc, 0xbd, 0x6f, 0xbe,   // 
 0x70, 0x63, 0xbf, 0x79, 0xe4, 0x78, 0xe5, 0xc0,   // 
 0xc1, 0xe6, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,   // 
};

void WrLCDnib(unsigned char data)	//  	 HD44780 in 4 pipes
{
  SET_E;
  PORTHDDATA=(__swap_nibbles(data) & MASKA_HDDATA)|(PORTHDDATA & 0x0f);
  __delay_cycles(300);
  CLR_E;
  __delay_cycles(300); //80 us
};

void WrLCDbyte(unsigned char data)	//  	 HD44780 in 4 pipes
{
  SET_E;
  PORTHDDATA=(data & MASKA_HDDATA)|(PORTHDDATA & 0x0f);
  __delay_cycles(300);
  CLR_E;
    __delay_cycles(300); //80 us
  SET_E;
  PORTHDDATA=(__swap_nibbles(data) & MASKA_HDDATA)|(PORTHDDATA & 0x0f);
  __delay_cycles(300);
  CLR_E;
   __delay_cycles(300); //80 us
};

void LCDstr (unsigned char *s)
{
unsigned int c;
while (*s !=0) {
 c=*s++;
if(c>=0x80){			//    , 
		 c -= 0x80;	//  
		 c = TabWin[c];
};
  WrLCDbyte(c);
};
};

void LCD_init (void)
{
DDRHDDATA=0xff;
CLR_RW;
CLR_E;
CLR_RS;//comand
  __delay_cycles(300000); //80 ms
WrLCDnib(0x03);//8-bit
WrLCDnib(0x03);//8-bit
WrLCDnib(0x03);//8-bit
WrLCDnib(0x02);//4-bit
WrLCDbyte(0x28);//4-bit,2-lines,5*7 chars
WrLCDbyte(0x0C);//
WrLCDbyte(0x01);//
  __delay_cycles(15000); //2 ms
WrLCDbyte(0x06);//
WrLCDbyte(0x02);//

SET_RS;
};
void SetLCD (unsigned char x, unsigned char y)
{
  unsigned char addr = 0x80 ;
  CLR_RS;
  if (y==2) addr=0xC0;
  addr = addr+x ;
  WrLCDbyte(addr);
  SET_RS;
};
void rLCD(void)
{
  unsigned char z;
  __disable_interrupt();
  if (str[s_pos]==0) s_pos=0;
  SetLCD(0,2);
  for(z=0; z<7; z++)
  {
buff[z]=buff[z+1];
  };
  buff[7]=str[s_pos];
  LCDstr(buff);
  s_pos++;
  gl_flags=gl_flags&!(1<<0);
  __enable_interrupt();
};

