#include <iom32.h>
#include <intrinsics.h>
#include <e:\ \avr\project\lcd.c>
#define FCPU                    7372800 // Hz freq MC

#define	PORTAXIS		PORTB
#define	PINAXIS			PINB
#define	DDRAXIS	        	DDRB
#define	STEPX			0
#define	STEPY			1
#define	DIRX			4
#define	DIRY			5

#define	SET_STEPALL		PORTAXIS|= (1<<STEPX)|(1<<STEPY)


unsigned char b1000=0,b100=0,b10=0,b1=0,am=0, d[2], T[2] ={0,0}, 
              Ti[2]={0,0}, tdir=0, temp, f, ty;
const unsigned char TT[17] = {0,0,0,24,24,21,18,15,12,10,7,5,4,3,2,1,1};
unsigned int adc_d, tem, a[2];

void bdc (int tempt) //  - 
{
b100=tempt/100;  
b10=(tempt-b100*100)/10;
b1=tempt-b100*100-b10*10;
}


void main( void )
{
DDRD=0xF3;
DDRAXIS=0xFF;
PORTD=0xF3;
PORTAXIS=0xFF;

TIFR=0;

TIMSK |=(1<<TOIE0)|(1<<TOIE2)|(1<<OCIE1A);// timer0 ovfl
TCCR1A |=(1<<COM1A0);
TCCR1B |=(1<<CS10)|(1<<WGM12);
OCR1A=294;

TCCR2=0x0; //t2 stop
TCNT2=0xF2; //1.8 mks

TCCR0=0x4; // div 64
TCNT0=0xFF; // 8 mks

GICR |=(1<<INT0)|(1<<INT1);

ADMUX=0x60; // vref=vcc, left, ADC0
ADCSRA=0xCE;

LCD_init();
SetLCD(0,1);

__enable_interrupt();

while(1)
{
bdc(T[0]);
SetLCD(0,1);
WrLCDbyte(b100+0x30);
WrLCDbyte(b10+0x30);
WrLCDbyte(b1+0x30);
bdc(T[1]);
SetLCD(4,1);
WrLCDbyte(b100+0x30);
WrLCDbyte(b10+0x30);
WrLCDbyte(b1+0x30);


}//whil

}//main


#pragma vector = TIMER1_OVF_vect //  Charge pomp 
__interrupt void t_1(void)
{
TCNT1=0xFD30;//100ms
}
#pragma vector = INT0_vect //  1
__interrupt void i_0(void)
{
temp=PIND;
  PORTD=(~temp&0x41)|(temp&0xBE);

}
#pragma vector = INT1_vect //  2
__interrupt void i_1(void)
{
temp=PIND;
  PORTD=(~temp&0x82)|(temp&0x7D);

}

#pragma vector = TIMER0_OVF_vect //  Step/Dir
__interrupt void t_0(void)
{
temp=0xff;
for (ty=0;ty<2;ty++)
{
if ((T[ty]==Ti[ty])&(T[ty]!=0))
{
   temp&=~(1<<ty);
   f=1;
   Ti[ty]=0;
} 
else
{
  Ti[ty]++;
}
}
if (f==1)
{
f=0;
PORTAXIS=temp&PORTAXIS;
TCCR2=0x1;
}
TCNT0=0xFf;
}




#pragma vector = TIMER2_OVF_vect //  Step
__interrupt void t_2(void)
{
SET_STEPALL;
TCCR2=0x0;
TCNT2=0xF2;
}


#pragma vector = ADC_vect //  
__interrupt void adc (void)
{
  a[am]=ADCH >> 3;
if (a[am]>15)
{
  PORTAXIS|=(1<<(4+am));
  a[am]=a[am]-15;
}
else
{
  PORTAXIS&=~(1<<(4+am));
  a[am]=15-a[am];
}
T[am]=TT[a[am]];
if (am<1)
{
  am++;
  ADMUX++;
}
else 
{
  am=0;
  ADMUX=0x60;
}
ADCSRA= ADCSRA|0x40;
}

